package PowerEdit::CMS;

use strict;
use warnings;

sub _power_edit_entries {
    my ($ctx, $args, $cond) = @_;

    my $class_type = $args->{class_type} || 'entry';
    my $class = MT->model ($class_type);
    my %terms = (
        id => $args->{id},
        class => $class_type,
    );
    my $e = $class->load(\%terms);
    my $builder = $ctx->stash('builder');
    local $ctx->{__stash}{entry} = $e;
    local $ctx->{current_timestamp} = $e->authored_on;
    my $out = $builder->build($ctx, $ctx->stash('tokens'), $cond);
    return $ctx->error( $builder->errstr ) unless defined $out;
    $out;
}

sub save_power_edit {
    my ($cb, $app, $entry, $org) = @_;
    my $q = $app->param;
    my $id = $entry->id;

    if ($id) {
        unless ($q->param('text')) {
            if ($q->param('text_' . $id )) {
                $entry->text($q->param('text_' . $id ));
            } else {
                $entry->text('');
            }
        }
        unless ($q->param('text_more')) {
            if ($q->param('text_more_' . $id )) {
                $entry->text_more($q->param('text_more_' . $id ));
            } else {
                $entry->text_more('');
            }
        }
#        unless ($q->param('excerpt')) {
#            if ($q->param('excerpt_' . $id )) {
#                $entry->excerpt($q->param('excerpt_' . $id ));
#            } else {
#                $entry->excerpt('');
#            }
#        }
        unless ($q->param('tags')) {
            if ($q->param('tags_' . $id )) {
                my @tags = split(/,\s*/,$q->param('tags_' . $id ));
                $entry->tags(@tags);
            } else {
                $entry->tags('');
            }
        }
        unless ($q->param('keywords')) {
            if ($q->param('keywords_' . $id )) {
                $entry->keywords($q->param('keywords_' . $id ));
            } else {
                $entry->keywords('');
            }
        }
        unless ($q->param('allow_comments')) {
            if ($q->param('allow_comments_' . $id )) {
                $entry->allow_comments(1);
            } else {
                $entry->allow_comments(0);
            }
        }
        unless ($q->param('allow_pings')) {
            if ($q->param('allow_pings_' . $id )) {
                $entry->allow_pings(1);
            } else {
                $entry->allow_pings(0);
            }
        }
    }
    return 1;
}

1;
